import React from 'react';
import { ThemeProps } from 'amis-core';
import { FormControlProps } from 'amis-core';
import { FormBaseControlSchema } from '../../Schema';
/**
 * Location 选点组件
 * 文档：https://aisuda.bce.baidu.com/amis/zh-CN/components/form/location
 */
export interface LocationControlSchema extends FormBaseControlSchema {
    type: 'location-picker';
    /**
     * 选择地图类型
     */
    vendor?: 'baidu' | 'gaode' | 'tenxun';
    /**
     * 有的地图需要设置 ak 信息
     */
    ak?: string;
}
export interface LocationControlProps extends FormControlProps, Omit<ThemeProps, 'className'>, Omit<LocationControlSchema, 'type' | 'className' | 'descriptionClassName' | 'inputClassName'> {
    value: any;
    onChange: (value: any) => void;
    vendor: 'baidu' | 'gaode' | 'tenxun';
    ak: string;
    coordinatesType: 'bd09' | 'gcj02';
}
export declare class LocationControl extends React.Component<LocationControlProps> {
    static defaultProps: {
        vendor: string;
        coordinatesType: string;
    };
    domRef: React.RefObject<HTMLDivElement>;
    state: {
        isOpened: boolean;
    };
    close(): void;
    open(): void;
    handleClick(): void;
    getParent(): HTMLElement | null | undefined;
    getTarget(): HTMLDivElement | null;
    renderStatic(displayValue?: string): React.JSX.Element;
    render(): React.JSX.Element;
}
export declare class LocationRenderer extends LocationControl {
}
